diff --git a/external/fmt/test/format-test.cc b/external/fmt/test/format-test.cc
index 2a25566c..a8592ef0 100644
--- a/external/fmt/test/format-test.cc
+++ b/external/fmt/test/format-test.cc
@@ -1107,296 +1100,324 @@ constexpr auto int128_min = -int128_max - 1;
 constexpr auto uint128_max = ~static_cast<__uint128_t>(0);
 #endif
 
-TEST(FormatterTest, FormatDec) {
-  EXPECT_EQ("0", format("{0}", 0));
-  EXPECT_EQ("42", format("{0}", 42));
-  EXPECT_EQ("42", format("{0:d}", 42));
-  EXPECT_EQ("42", format("{0}", 42u));
-  EXPECT_EQ("-42", format("{0}", -42));
-  EXPECT_EQ("12345", format("{0}", 12345));
-  EXPECT_EQ("67890", format("{0}", 67890));
+TEST(format_test, format_dec) {
+  EXPECT_EQ("0", fmt::format("{0}", 0));
+  EXPECT_EQ("42", fmt::format("{0}", 42));
+  EXPECT_EQ("42", fmt::format("{0:d}", 42));
+  EXPECT_EQ("42", fmt::format("{0}", 42u));
+  EXPECT_EQ("-42", fmt::format("{0}", -42));
+  EXPECT_EQ("12345", fmt::format("{0}", 12345));
+  EXPECT_EQ("67890", fmt::format("{0}", 67890));
 #if FMT_USE_INT128
-  EXPECT_EQ("0", format("{0}", static_cast<__int128_t>(0)));
-  EXPECT_EQ("0", format("{0}", static_cast<__uint128_t>(0)));
+  EXPECT_EQ("0", fmt::format("{0}", static_cast<__int128_t>(0)));
+  EXPECT_EQ("0", fmt::format("{0}", static_cast<__uint128_t>(0)));
   EXPECT_EQ("9223372036854775808",
-            format("{0}", static_cast<__int128_t>(INT64_MAX) + 1));
+            fmt::format("{0}", static_cast<__int128_t>(INT64_MAX) + 1));
   EXPECT_EQ("-9223372036854775809",
-            format("{0}", static_cast<__int128_t>(INT64_MIN) - 1));
+            fmt::format("{0}", static_cast<__int128_t>(INT64_MIN) - 1));
   EXPECT_EQ("18446744073709551616",
-            format("{0}", static_cast<__int128_t>(UINT64_MAX) + 1));
+            fmt::format("{0}", static_cast<__int128_t>(UINT64_MAX) + 1));
   EXPECT_EQ("170141183460469231731687303715884105727",
-            format("{0}", int128_max));
+            fmt::format("{0}", int128_max));
   EXPECT_EQ("-170141183460469231731687303715884105728",
-            format("{0}", int128_min));
+            fmt::format("{0}", int128_min));
   EXPECT_EQ("340282366920938463463374607431768211455",
-            format("{0}", uint128_max));
+            fmt::format("{0}", uint128_max));
 #endif
 
-  char buffer[BUFFER_SIZE];
+  char buffer[buffer_size];
   safe_sprintf(buffer, "%d", INT_MIN);
-  EXPECT_EQ(buffer, format("{0}", INT_MIN));
+  EXPECT_EQ(buffer, fmt::format("{0}", INT_MIN));
   safe_sprintf(buffer, "%d", INT_MAX);
-  EXPECT_EQ(buffer, format("{0}", INT_MAX));
+  EXPECT_EQ(buffer, fmt::format("{0}", INT_MAX));
   safe_sprintf(buffer, "%u", UINT_MAX);
-  EXPECT_EQ(buffer, format("{0}", UINT_MAX));
+  EXPECT_EQ(buffer, fmt::format("{0}", UINT_MAX));
   safe_sprintf(buffer, "%ld", 0 - static_cast<unsigned long>(LONG_MIN));
-  EXPECT_EQ(buffer, format("{0}", LONG_MIN));
+  EXPECT_EQ(buffer, fmt::format("{0}", LONG_MIN));
   safe_sprintf(buffer, "%ld", LONG_MAX);
-  EXPECT_EQ(buffer, format("{0}", LONG_MAX));
+  EXPECT_EQ(buffer, fmt::format("{0}", LONG_MAX));
   safe_sprintf(buffer, "%lu", ULONG_MAX);
-  EXPECT_EQ(buffer, format("{0}", ULONG_MAX));
-}
-
-TEST(FormatterTest, FormatHex) {
-  EXPECT_EQ("0", format("{0:x}", 0));
-  EXPECT_EQ("42", format("{0:x}", 0x42));
-  EXPECT_EQ("42", format("{0:x}", 0x42u));
-  EXPECT_EQ("-42", format("{0:x}", -0x42));
-  EXPECT_EQ("12345678", format("{0:x}", 0x12345678));
-  EXPECT_EQ("90abcdef", format("{0:x}", 0x90abcdef));
-  EXPECT_EQ("12345678", format("{0:X}", 0x12345678));
-  EXPECT_EQ("90ABCDEF", format("{0:X}", 0x90ABCDEF));
+  EXPECT_EQ(buffer, fmt::format("{0}", ULONG_MAX));
+}
+
+TEST(format_test, format_hex) {
+  EXPECT_EQ("0", fmt::format("{0:x}", 0));
+  EXPECT_EQ("42", fmt::format("{0:x}", 0x42));
+  EXPECT_EQ("42", fmt::format("{0:x}", 0x42u));
+  EXPECT_EQ("-42", fmt::format("{0:x}", -0x42));
+  EXPECT_EQ("12345678", fmt::format("{0:x}", 0x12345678));
+  EXPECT_EQ("90abcdef", fmt::format("{0:x}", 0x90abcdef));
+  EXPECT_EQ("12345678", fmt::format("{0:X}", 0x12345678));
+  EXPECT_EQ("90ABCDEF", fmt::format("{0:X}", 0x90ABCDEF));
 #if FMT_USE_INT128
-  EXPECT_EQ("0", format("{0:x}", static_cast<__int128_t>(0)));
-  EXPECT_EQ("0", format("{0:x}", static_cast<__uint128_t>(0)));
+  EXPECT_EQ("0", fmt::format("{0:x}", static_cast<__int128_t>(0)));
+  EXPECT_EQ("0", fmt::format("{0:x}", static_cast<__uint128_t>(0)));
   EXPECT_EQ("8000000000000000",
-            format("{0:x}", static_cast<__int128_t>(INT64_MAX) + 1));
+            fmt::format("{0:x}", static_cast<__int128_t>(INT64_MAX) + 1));
   EXPECT_EQ("-8000000000000001",
-            format("{0:x}", static_cast<__int128_t>(INT64_MIN) - 1));
+            fmt::format("{0:x}", static_cast<__int128_t>(INT64_MIN) - 1));
   EXPECT_EQ("10000000000000000",
-            format("{0:x}", static_cast<__int128_t>(UINT64_MAX) + 1));
-  EXPECT_EQ("7fffffffffffffffffffffffffffffff", format("{0:x}", int128_max));
-  EXPECT_EQ("-80000000000000000000000000000000", format("{0:x}", int128_min));
-  EXPECT_EQ("ffffffffffffffffffffffffffffffff", format("{0:x}", uint128_max));
+            fmt::format("{0:x}", static_cast<__int128_t>(UINT64_MAX) + 1));
+  EXPECT_EQ("7fffffffffffffffffffffffffffffff",
+            fmt::format("{0:x}", int128_max));
+  EXPECT_EQ("-80000000000000000000000000000000",
+            fmt::format("{0:x}", int128_min));
+  EXPECT_EQ("ffffffffffffffffffffffffffffffff",
+            fmt::format("{0:x}", uint128_max));
 #endif
 
-  char buffer[BUFFER_SIZE];
+  char buffer[buffer_size];
   safe_sprintf(buffer, "-%x", 0 - static_cast<unsigned>(INT_MIN));
-  EXPECT_EQ(buffer, format("{0:x}", INT_MIN));
+  EXPECT_EQ(buffer, fmt::format("{0:x}", INT_MIN));
   safe_sprintf(buffer, "%x", INT_MAX);
-  EXPECT_EQ(buffer, format("{0:x}", INT_MAX));
+  EXPECT_EQ(buffer, fmt::format("{0:x}", INT_MAX));
   safe_sprintf(buffer, "%x", UINT_MAX);
-  EXPECT_EQ(buffer, format("{0:x}", UINT_MAX));
+  EXPECT_EQ(buffer, fmt::format("{0:x}", UINT_MAX));
   safe_sprintf(buffer, "-%lx", 0 - static_cast<unsigned long>(LONG_MIN));
-  EXPECT_EQ(buffer, format("{0:x}", LONG_MIN));
+  EXPECT_EQ(buffer, fmt::format("{0:x}", LONG_MIN));
   safe_sprintf(buffer, "%lx", LONG_MAX);
-  EXPECT_EQ(buffer, format("{0:x}", LONG_MAX));
+  EXPECT_EQ(buffer, fmt::format("{0:x}", LONG_MAX));
   safe_sprintf(buffer, "%lx", ULONG_MAX);
-  EXPECT_EQ(buffer, format("{0:x}", ULONG_MAX));
+  EXPECT_EQ(buffer, fmt::format("{0:x}", ULONG_MAX));
 }
 
-TEST(FormatterTest, FormatOct) {
-  EXPECT_EQ("0", format("{0:o}", 0));
-  EXPECT_EQ("42", format("{0:o}", 042));
-  EXPECT_EQ("42", format("{0:o}", 042u));
-  EXPECT_EQ("-42", format("{0:o}", -042));
-  EXPECT_EQ("12345670", format("{0:o}", 012345670));
+TEST(format_test, format_oct) {
+  EXPECT_EQ("0", fmt::format("{0:o}", 0));
+  EXPECT_EQ("42", fmt::format("{0:o}", 042));
+  EXPECT_EQ("42", fmt::format("{0:o}", 042u));
+  EXPECT_EQ("-42", fmt::format("{0:o}", -042));
+  EXPECT_EQ("12345670", fmt::format("{0:o}", 012345670));
 #if FMT_USE_INT128
-  EXPECT_EQ("0", format("{0:o}", static_cast<__int128_t>(0)));
-  EXPECT_EQ("0", format("{0:o}", static_cast<__uint128_t>(0)));
+  EXPECT_EQ("0", fmt::format("{0:o}", static_cast<__int128_t>(0)));
+  EXPECT_EQ("0", fmt::format("{0:o}", static_cast<__uint128_t>(0)));
   EXPECT_EQ("1000000000000000000000",
-            format("{0:o}", static_cast<__int128_t>(INT64_MAX) + 1));
+            fmt::format("{0:o}", static_cast<__int128_t>(INT64_MAX) + 1));
   EXPECT_EQ("-1000000000000000000001",
-            format("{0:o}", static_cast<__int128_t>(INT64_MIN) - 1));
+            fmt::format("{0:o}", static_cast<__int128_t>(INT64_MIN) - 1));
   EXPECT_EQ("2000000000000000000000",
-            format("{0:o}", static_cast<__int128_t>(UINT64_MAX) + 1));
+            fmt::format("{0:o}", static_cast<__int128_t>(UINT64_MAX) + 1));
   EXPECT_EQ("1777777777777777777777777777777777777777777",
-            format("{0:o}", int128_max));
+            fmt::format("{0:o}", int128_max));
   EXPECT_EQ("-2000000000000000000000000000000000000000000",
-            format("{0:o}", int128_min));
+            fmt::format("{0:o}", int128_min));
   EXPECT_EQ("3777777777777777777777777777777777777777777",
-            format("{0:o}", uint128_max));
+            fmt::format("{0:o}", uint128_max));
 #endif
 
-  char buffer[BUFFER_SIZE];
+  char buffer[buffer_size];
   safe_sprintf(buffer, "-%o", 0 - static_cast<unsigned>(INT_MIN));
-  EXPECT_EQ(buffer, format("{0:o}", INT_MIN));
+  EXPECT_EQ(buffer, fmt::format("{0:o}", INT_MIN));
   safe_sprintf(buffer, "%o", INT_MAX);
-  EXPECT_EQ(buffer, format("{0:o}", INT_MAX));
+  EXPECT_EQ(buffer, fmt::format("{0:o}", INT_MAX));
   safe_sprintf(buffer, "%o", UINT_MAX);
-  EXPECT_EQ(buffer, format("{0:o}", UINT_MAX));
+  EXPECT_EQ(buffer, fmt::format("{0:o}", UINT_MAX));
   safe_sprintf(buffer, "-%lo", 0 - static_cast<unsigned long>(LONG_MIN));
-  EXPECT_EQ(buffer, format("{0:o}", LONG_MIN));
+  EXPECT_EQ(buffer, fmt::format("{0:o}", LONG_MIN));
   safe_sprintf(buffer, "%lo", LONG_MAX);
-  EXPECT_EQ(buffer, format("{0:o}", LONG_MAX));
+  EXPECT_EQ(buffer, fmt::format("{0:o}", LONG_MAX));
   safe_sprintf(buffer, "%lo", ULONG_MAX);
-  EXPECT_EQ(buffer, format("{0:o}", ULONG_MAX));
-}
-
-TEST(FormatterTest, FormatIntLocale) {
-  EXPECT_EQ("1234", format("{:L}", 1234));
+  EXPECT_EQ(buffer, fmt::format("{0:o}", ULONG_MAX));
 }
 
-struct ConvertibleToLongLong {
-  operator long long() const { return 1LL << 32; }
-};
-
-TEST(FormatterTest, FormatConvertibleToLongLong) {
-  EXPECT_EQ("100000000", format("{:x}", ConvertibleToLongLong()));
+TEST(format_test, format_int_locale) {
+  EXPECT_EQ("1234", fmt::format("{:L}", 1234));
 }
 
-TEST(FormatterTest, FormatFloat) {
-  EXPECT_EQ("392.500000", format("{0:f}", 392.5f));
+TEST(format_test, format_float) {
+  EXPECT_EQ("0", fmt::format("{}", 0.0f));
+  EXPECT_EQ("392.500000", fmt::format("{0:f}", 392.5f));
 }
 
-TEST(FormatterTest, FormatDouble) {
+TEST(format_test, format_double) {
+  EXPECT_EQ("0", fmt::format("{}", 0.0));
   check_unknown_types(1.2, "eEfFgGaAnL%", "double");
-  EXPECT_EQ("0.0", format("{:}", 0.0));
-  EXPECT_EQ("0.000000", format("{:f}", 0.0));
-  EXPECT_EQ("0", format("{:g}", 0.0));
-  EXPECT_EQ("392.65", format("{:}", 392.65));
-  EXPECT_EQ("392.65", format("{:g}", 392.65));
-  EXPECT_EQ("392.65", format("{:G}", 392.65));
-  EXPECT_EQ("392.650000", format("{:f}", 392.65));
-  EXPECT_EQ("392.650000", format("{:F}", 392.65));
-  EXPECT_EQ("42", format("{:L}", 42.0));
-  char buffer[BUFFER_SIZE];
+  EXPECT_EQ("0", fmt::format("{:}", 0.0));
+  EXPECT_EQ("0.000000", fmt::format("{:f}", 0.0));
+  EXPECT_EQ("0", fmt::format("{:g}", 0.0));
+  EXPECT_EQ("392.65", fmt::format("{:}", 392.65));
+  EXPECT_EQ("392.65", fmt::format("{:g}", 392.65));
+  EXPECT_EQ("392.65", fmt::format("{:G}", 392.65));
+  EXPECT_EQ("4.9014e+06", fmt::format("{:g}", 4.9014e6));
+  EXPECT_EQ("392.650000", fmt::format("{:f}", 392.65));
+  EXPECT_EQ("392.650000", fmt::format("{:F}", 392.65));
+  EXPECT_EQ("42", fmt::format("{:L}", 42.0));
+  EXPECT_EQ("    0x1.0cccccccccccdp+2", fmt::format("{:24a}", 4.2));
+  EXPECT_EQ("0x1.0cccccccccccdp+2    ", fmt::format("{:<24a}", 4.2));
+  char buffer[buffer_size];
   safe_sprintf(buffer, "%e", 392.65);
-  EXPECT_EQ(buffer, format("{0:e}", 392.65));
+  EXPECT_EQ(buffer, fmt::format("{0:e}", 392.65));
   safe_sprintf(buffer, "%E", 392.65);
-  EXPECT_EQ(buffer, format("{0:E}", 392.65));
-  EXPECT_EQ("+0000392.6", format("{0:+010.4g}", 392.65));
+  EXPECT_EQ(buffer, fmt::format("{0:E}", 392.65));
+  EXPECT_EQ("+0000392.6", fmt::format("{0:+010.4g}", 392.65));
   safe_sprintf(buffer, "%a", -42.0);
-  EXPECT_EQ(buffer, format("{:a}", -42.0));
+  EXPECT_EQ(buffer, fmt::format("{:a}", -42.0));
   safe_sprintf(buffer, "%A", -42.0);
-  EXPECT_EQ(buffer, format("{:A}", -42.0));
-}
-
-TEST(FormatterTest, PrecisionRounding) {
-  EXPECT_EQ("0", format("{:.0f}", 0.0));
-  EXPECT_EQ("0", format("{:.0f}", 0.01));
-  EXPECT_EQ("0", format("{:.0f}", 0.1));
-  EXPECT_EQ("0.000", format("{:.3f}", 0.00049));
-  EXPECT_EQ("0.001", format("{:.3f}", 0.0005));
-  EXPECT_EQ("0.001", format("{:.3f}", 0.00149));
-  EXPECT_EQ("0.002", format("{:.3f}", 0.0015));
-  EXPECT_EQ("1.000", format("{:.3f}", 0.9999));
-  EXPECT_EQ("0.00123", format("{:.3}", 0.00123));
-  EXPECT_EQ("0.1", format("{:.16g}", 0.1));
-  // Trigger rounding error in Grisu by a carefully chosen number.
-  auto n = 3788512123356.985352;
-  char buffer[64];
-  safe_sprintf(buffer, "%f", n);
-  EXPECT_EQ(buffer, format("{:f}", n));
-}
-
-TEST(FormatterTest, FormatNaN) {
+  EXPECT_EQ(buffer, fmt::format("{:A}", -42.0));
+  EXPECT_EQ("9223372036854775808.000000",
+            fmt::format("{:f}", 9223372036854775807.0));
+}
+
+TEST(format_test, precision_rounding) {
+  EXPECT_EQ("0", fmt::format("{:.0f}", 0.0));
+  EXPECT_EQ("0", fmt::format("{:.0f}", 0.01));
+  EXPECT_EQ("0", fmt::format("{:.0f}", 0.1));
+  EXPECT_EQ("0.000", fmt::format("{:.3f}", 0.00049));
+  EXPECT_EQ("0.001", fmt::format("{:.3f}", 0.0005));
+  EXPECT_EQ("0.001", fmt::format("{:.3f}", 0.00149));
+  EXPECT_EQ("0.002", fmt::format("{:.3f}", 0.0015));
+  EXPECT_EQ("1.000", fmt::format("{:.3f}", 0.9999));
+  EXPECT_EQ("0.00123", fmt::format("{:.3}", 0.00123));
+  EXPECT_EQ("0.1", fmt::format("{:.16g}", 0.1));
+  EXPECT_EQ("1", fmt::format("{:.0}", 1.0));
+  EXPECT_EQ("225.51575035152063720",
+            fmt::format("{:.17f}", 225.51575035152064));
+  EXPECT_EQ("-761519619559038.2", fmt::format("{:.1f}", -761519619559038.2));
+  EXPECT_EQ("1.9156918820264798e-56",
+            fmt::format("{}", 1.9156918820264798e-56));
+  EXPECT_EQ("0.0000", fmt::format("{:.4f}", 7.2809479766055470e-15));
+
+  // Trigger a rounding error in Grisu by a specially chosen number.
+  EXPECT_EQ("3788512123356.985352", fmt::format("{:f}", 3788512123356.985352));
+}
+
+TEST(format_test, prettify_float) {
+  EXPECT_EQ("0.0001", fmt::format("{}", 1e-4));
+  EXPECT_EQ("1e-05", fmt::format("{}", 1e-5));
+  EXPECT_EQ("1000000000000000", fmt::format("{}", 1e15));
+  EXPECT_EQ("1e+16", fmt::format("{}", 1e16));
+  EXPECT_EQ("9.999e-05", fmt::format("{}", 9.999e-5));
+  EXPECT_EQ("10000000000", fmt::format("{}", 1e10));
+  EXPECT_EQ("100000000000", fmt::format("{}", 1e11));
+  EXPECT_EQ("12340000000", fmt::format("{}", 1234e7));
+  EXPECT_EQ("12.34", fmt::format("{}", 1234e-2));
+  EXPECT_EQ("0.001234", fmt::format("{}", 1234e-6));
+  EXPECT_EQ("0.1", fmt::format("{}", 0.1f));
+  EXPECT_EQ("0.10000000149011612", fmt::format("{}", double(0.1f)));
+  EXPECT_EQ("1.3563156e-19", fmt::format("{}", 1.35631564e-19f));
+}
+
+TEST(format_test, format_nan) {
   double nan = std::numeric_limits<double>::quiet_NaN();
-  EXPECT_EQ("nan", format("{}", nan));
-  EXPECT_EQ("+nan", format("{:+}", nan));
-  EXPECT_EQ(" nan", format("{: }", nan));
-  EXPECT_EQ("NAN", format("{:F}", nan));
-  EXPECT_EQ("nan    ", format("{:<7}", nan));
-  EXPECT_EQ("  nan  ", format("{:^7}", nan));
-  EXPECT_EQ("    nan", format("{:>7}", nan));
+  EXPECT_EQ("nan", fmt::format("{}", nan));
+  EXPECT_EQ("+nan", fmt::format("{:+}", nan));
+  EXPECT_EQ("  +nan", fmt::format("{:+06}", nan));
+  EXPECT_EQ("+nan  ", fmt::format("{:<+06}", nan));
+  EXPECT_EQ(" +nan ", fmt::format("{:^+06}", nan));
+  EXPECT_EQ("  +nan", fmt::format("{:>+06}", nan));
+  if (std::signbit(-nan)) {
+    EXPECT_EQ("-nan", fmt::format("{}", -nan));
+    EXPECT_EQ("  -nan", fmt::format("{:+06}", -nan));
+  } else {
+    fmt::print("Warning: compiler doesn't handle negative NaN correctly");
+  }
+  EXPECT_EQ(" nan", fmt::format("{: }", nan));
+  EXPECT_EQ("NAN", fmt::format("{:F}", nan));
+  EXPECT_EQ("nan    ", fmt::format("{:<7}", nan));
+  EXPECT_EQ("  nan  ", fmt::format("{:^7}", nan));
+  EXPECT_EQ("    nan", fmt::format("{:>7}", nan));
 }
 
-TEST(FormatterTest, FormatInfinity) {
+TEST(format_test, format_infinity) {
   double inf = std::numeric_limits<double>::infinity();
-  EXPECT_EQ("inf", format("{}", inf));
-  EXPECT_EQ("+inf", format("{:+}", inf));
-  EXPECT_EQ("-inf", format("{}", -inf));
-  EXPECT_EQ(" inf", format("{: }", inf));
-  EXPECT_EQ("INF", format("{:F}", inf));
-  EXPECT_EQ("inf    ", format("{:<7}", inf));
-  EXPECT_EQ("  inf  ", format("{:^7}", inf));
-  EXPECT_EQ("    inf", format("{:>7}", inf));
-}
-
-TEST(FormatterTest, FormatLongDouble) {
-  EXPECT_EQ("0.0", format("{0:}", 0.0l));
-  EXPECT_EQ("0.000000", format("{0:f}", 0.0l));
-  EXPECT_EQ("392.65", format("{0:}", 392.65l));
-  EXPECT_EQ("392.65", format("{0:g}", 392.65l));
-  EXPECT_EQ("392.65", format("{0:G}", 392.65l));
-  EXPECT_EQ("392.650000", format("{0:f}", 392.65l));
-  EXPECT_EQ("392.650000", format("{0:F}", 392.65l));
-  char buffer[BUFFER_SIZE];
+  EXPECT_EQ("inf", fmt::format("{}", inf));
+  EXPECT_EQ("+inf", fmt::format("{:+}", inf));
+  EXPECT_EQ("-inf", fmt::format("{}", -inf));
+  EXPECT_EQ("  +inf", fmt::format("{:+06}", inf));
+  EXPECT_EQ("  -inf", fmt::format("{:+06}", -inf));
+  EXPECT_EQ("+inf  ", fmt::format("{:<+06}", inf));
+  EXPECT_EQ(" +inf ", fmt::format("{:^+06}", inf));
+  EXPECT_EQ("  +inf", fmt::format("{:>+06}", inf));
+  EXPECT_EQ(" inf", fmt::format("{: }", inf));
+  EXPECT_EQ("INF", fmt::format("{:F}", inf));
+  EXPECT_EQ("inf    ", fmt::format("{:<7}", inf));
+  EXPECT_EQ("  inf  ", fmt::format("{:^7}", inf));
+  EXPECT_EQ("    inf", fmt::format("{:>7}", inf));
+}
+
+TEST(format_test, format_long_double) {
+  EXPECT_EQ("0", fmt::format("{0:}", 0.0l));
+  EXPECT_EQ("0.000000", fmt::format("{0:f}", 0.0l));
+  EXPECT_EQ("392.65", fmt::format("{0:}", 392.65l));
+  EXPECT_EQ("392.65", fmt::format("{0:g}", 392.65l));
+  EXPECT_EQ("392.65", fmt::format("{0:G}", 392.65l));
+  EXPECT_EQ("392.650000", fmt::format("{0:f}", 392.65l));
+  EXPECT_EQ("392.650000", fmt::format("{0:F}", 392.65l));
+  char buffer[buffer_size];
   safe_sprintf(buffer, "%Le", 392.65l);
-  EXPECT_EQ(buffer, format("{0:e}", 392.65l));
-  EXPECT_EQ("+0000392.6", format("{0:+010.4g}", 392.64l));
+  EXPECT_EQ(buffer, fmt::format("{0:e}", 392.65l));
+  EXPECT_EQ("+0000392.6", fmt::format("{0:+010.4g}", 392.64l));
   safe_sprintf(buffer, "%La", 3.31l);
-  EXPECT_EQ(buffer, format("{:a}", 3.31l));
+  EXPECT_EQ(buffer, fmt::format("{:a}", 3.31l));
 }
 
-TEST(FormatterTest, FormatChar) {
-  const char types[] = "cbBdoxXL";
+TEST(format_test, format_char) {
+  const char types[] = "cbBdoxX";
   check_unknown_types('a', types, "char");
-  EXPECT_EQ("a", format("{0}", 'a'));
-  EXPECT_EQ("z", format("{0:c}", 'z'));
-  EXPECT_EQ(L"a", format(L"{0}", 'a'));
+  EXPECT_EQ("a", fmt::format("{0}", 'a'));
+  EXPECT_EQ("z", fmt::format("{0:c}", 'z'));
   int n = 'x';
   for (const char* type = types + 1; *type; ++type) {
     std::string format_str = fmt::format("{{:{}}}", *type);
-    EXPECT_EQ(fmt::format(format_str, n), fmt::format(format_str, 'x'));
+    EXPECT_EQ(fmt::format(runtime(format_str), n),
+              fmt::format(runtime(format_str), 'x'))
+        << format_str;
   }
   EXPECT_EQ(fmt::format("{:02X}", n), fmt::format("{:02X}", 'x'));
 }
 
-TEST(FormatterTest, FormatVolatileChar) {
+TEST(format_test, format_volatile_char) {
   volatile char c = 'x';
-  EXPECT_EQ("x", format("{}", c));
-}
-
-TEST(FormatterTest, FormatUnsignedChar) {
-  EXPECT_EQ("42", format("{}", static_cast<unsigned char>(42)));
-  EXPECT_EQ("42", format("{}", static_cast<uint8_t>(42)));
+  EXPECT_EQ("x", fmt::format("{}", c));
 }
 
-TEST(FormatterTest, FormatWChar) {
-  EXPECT_EQ(L"a", format(L"{0}", L'a'));
-  // This shouldn't compile:
-  // format("{}", L'a');
+TEST(format_test, format_unsigned_char) {
+  EXPECT_EQ("42", fmt::format("{}", static_cast<unsigned char>(42)));
+  EXPECT_EQ("42", fmt::format("{}", static_cast<uint8_t>(42)));
 }
 
-TEST(FormatterTest, FormatCString) {
+TEST(format_test, format_cstring) {
   check_unknown_types("test", "sp", "string");
-  EXPECT_EQ("test", format("{0}", "test"));
-  EXPECT_EQ("test", format("{0:s}", "test"));
+  EXPECT_EQ("test", fmt::format("{0}", "test"));
+  EXPECT_EQ("test", fmt::format("{0:s}", "test"));
   char nonconst[] = "nonconst";
-  EXPECT_EQ("nonconst", format("{0}", nonconst));
-  EXPECT_THROW_MSG(format("{0}", static_cast<const char*>(nullptr)),
-                   format_error, "string pointer is null");
+  EXPECT_EQ("nonconst", fmt::format("{0}", nonconst));
+  EXPECT_THROW_MSG(
+      (void)fmt::format(runtime("{0}"), static_cast<const char*>(nullptr)),
+      format_error, "string pointer is null");
 }
 
-TEST(FormatterTest, FormatSCharString) {
-  signed char str[] = "test";
-  EXPECT_EQ("test", format("{0:s}", str));
-  const signed char* const_str = str;
-  EXPECT_EQ("test", format("{0:s}", const_str));
-}
+void function_pointer_test(int, double, std::string) {}
 
-TEST(FormatterTest, FormatUCharString) {
-  unsigned char str[] = "test";
-  EXPECT_EQ("test", format("{0:s}", str));
-  const unsigned char* const_str = str;
-  EXPECT_EQ("test", format("{0:s}", const_str));
-  unsigned char* ptr = str;
-  EXPECT_EQ("test", format("{0:s}", ptr));
-}
-
-TEST(FormatterTest, FormatPointer) {
+TEST(format_test, format_pointer) {
   check_unknown_types(reinterpret_cast<void*>(0x1234), "p", "pointer");
-  EXPECT_EQ("0x0", format("{0}", static_cast<void*>(nullptr)));
-  EXPECT_EQ("0x1234", format("{0}", reinterpret_cast<void*>(0x1234)));
-  EXPECT_EQ("0x1234", format("{0:p}", reinterpret_cast<void*>(0x1234)));
+  EXPECT_EQ("0x0", fmt::format("{0}", static_cast<void*>(nullptr)));
+  EXPECT_EQ("0x1234", fmt::format("{0}", reinterpret_cast<void*>(0x1234)));
+  EXPECT_EQ("0x1234", fmt::format("{0:p}", reinterpret_cast<void*>(0x1234)));
   EXPECT_EQ("0x" + std::string(sizeof(void*) * CHAR_BIT / 4, 'f'),
-            format("{0}", reinterpret_cast<void*>(~uintptr_t())));
-  EXPECT_EQ("0x1234", format("{}", fmt::ptr(reinterpret_cast<int*>(0x1234))));
+            fmt::format("{0}", reinterpret_cast<void*>(~uintptr_t())));
+  EXPECT_EQ("0x1234",
+            fmt::format("{}", fmt::ptr(reinterpret_cast<int*>(0x1234))));
   std::unique_ptr<int> up(new int(1));
-  EXPECT_EQ(format("{}", fmt::ptr(up.get())), format("{}", fmt::ptr(up)));
+  EXPECT_EQ(fmt::format("{}", fmt::ptr(up.get())),
+            fmt::format("{}", fmt::ptr(up)));
   std::shared_ptr<int> sp(new int(1));
-  EXPECT_EQ(format("{}", fmt::ptr(sp.get())), format("{}", fmt::ptr(sp)));
-  EXPECT_EQ("0x0", format("{}", nullptr));
+  EXPECT_EQ(fmt::format("{}", fmt::ptr(sp.get())),
+            fmt::format("{}", fmt::ptr(sp)));
+  EXPECT_EQ(fmt::format("{}", fmt::detail::bit_cast<const void*>(
+                                  &function_pointer_test)),
+            fmt::format("{}", fmt::ptr(function_pointer_test)));
+  EXPECT_EQ("0x0", fmt::format("{}", nullptr));
 }
 
-TEST(FormatterTest, FormatString) {
-  EXPECT_EQ("test", format("{0}", std::string("test")));
+TEST(format_test, format_string) {
+  EXPECT_EQ("test", fmt::format("{0}", std::string("test")));
+  EXPECT_THROW((void)fmt::format(fmt::runtime("{:x}"), std::string("test")),
+               fmt::format_error);
 }
 
-TEST(FormatterTest, FormatStringView) {
-  EXPECT_EQ("test", format("{}", string_view("test")));
-  EXPECT_EQ("", format("{}", string_view()));
+TEST(format_test, format_string_view) {
+  EXPECT_EQ("test", fmt::format("{}", string_view("test")));
+  EXPECT_EQ("", fmt::format("{}", string_view()));
 }
 
 #ifdef FMT_USE_STRING_VIEW
@@ -1410,68 +1431,55 @@ template <> struct formatter<string_viewable> : formatter<std::string_view> {
 };
 FMT_END_NAMESPACE
 
-TEST(FormatterTest, FormatStdStringView) {
-  EXPECT_EQ("test", format("{}", std::string_view("test")));
-  EXPECT_EQ("foo", format("{}", string_viewable()));
+TEST(format_test, format_std_string_view) {
+  EXPECT_EQ("test", fmt::format("{}", std::string_view("test")));
+  EXPECT_EQ("foo", fmt::format("{}", string_viewable()));
 }
 
 struct explicitly_convertible_to_std_string_view {
   explicit operator std::string_view() const { return "foo"; }
 };
 
-namespace fmt {
 template <>
-struct formatter<explicitly_convertible_to_std_string_view>
+struct fmt::formatter<explicitly_convertible_to_std_string_view>
     : formatter<std::string_view> {
-  auto format(const explicitly_convertible_to_std_string_view& v,
-              format_context& ctx) -> decltype(ctx.out()) {
+  auto format(explicitly_convertible_to_std_string_view v, format_context& ctx)
+      -> decltype(ctx.out()) {
     return format_to(ctx.out(), "'{}'", std::string_view(v));
   }
 };
-}  // namespace fmt
 
-TEST(FormatterTest, FormatExplicitlyConvertibleToStdStringView) {
+TEST(format_test, format_explicitly_convertible_to_std_string_view) {
   EXPECT_EQ("'foo'",
             fmt::format("{}", explicitly_convertible_to_std_string_view()));
 }
 #endif
 
-// std::is_constructible is broken in MSVC until version 2015.
-#if !FMT_MSC_VER || FMT_MSC_VER >= 1900
-struct explicitly_convertible_to_wstring_view {
-  explicit operator fmt::wstring_view() const { return L"foo"; }
+struct converible_to_anything {
+  template <typename T> operator T() const { return T(); }
 };
 
-TEST(FormatTest, FormatExplicitlyConvertibleToWStringView) {
-  EXPECT_EQ(L"foo",
-            fmt::format(L"{}", explicitly_convertible_to_wstring_view()));
-}
-#endif
-
-namespace fake_qt {
-class QString {
- public:
-  QString(const wchar_t* s) : s_(std::make_shared<std::wstring>(s)) {}
-  const wchar_t* utf16() const FMT_NOEXCEPT { return s_->data(); }
-  int size() const FMT_NOEXCEPT { return static_cast<int>(s_->size()); }
+FMT_BEGIN_NAMESPACE
+template <> struct formatter<converible_to_anything> {
+  FMT_CONSTEXPR auto parse(format_parse_context& ctx) -> decltype(ctx.begin()) {
+    return ctx.begin();
+  }
 
- private:
-  std::shared_ptr<std::wstring> s_;
+  auto format(converible_to_anything, format_context& ctx)
+      -> decltype(ctx.out()) {
+    return format_to(ctx.out(), "foo");
+  }
 };
+FMT_END_NAMESPACE
 
-fmt::basic_string_view<wchar_t> to_string_view(const QString& s) FMT_NOEXCEPT {
-  return {s.utf16(), static_cast<size_t>(s.size())};
+TEST(format_test, format_convertible_to_anything) {
+  EXPECT_EQ("foo", fmt::format("{}", converible_to_anything()));
 }
-}  // namespace fake_qt
 
-TEST(FormatTest, FormatForeignStrings) {
-  using fake_qt::QString;
-  EXPECT_EQ(fmt::format(QString(L"{}"), 42), L"42");
-  EXPECT_EQ(fmt::format(QString(L"{}"), QString(L"42")), L"42");
-}
+class Answer {};
 
 FMT_BEGIN_NAMESPACE
-template <> struct formatter<Date> {
+template <> struct formatter<date> {
   template <typename ParseContext>
   FMT_CONSTEXPR auto parse(ParseContext& ctx) -> decltype(ctx.begin()) {
     auto it = ctx.begin();
@@ -1479,22 +1487,12 @@ template <> struct formatter<Date> {
     return it;
   }
 
-  auto format(const Date& d, format_context& ctx) -> decltype(ctx.out()) {
+  auto format(const date& d, format_context& ctx) -> decltype(ctx.out()) {
     format_to(ctx.out(), "{}-{}-{}", d.year(), d.month(), d.day());
     return ctx.out();
   }
 };
-FMT_END_NAMESPACE
 
-TEST(FormatterTest, FormatCustom) {
-  Date date(2012, 12, 9);
-  EXPECT_THROW_MSG(fmt::format("{:s}", date), format_error,
-                   "unknown format specifier");
-}
-
-class Answer {};
-
-FMT_BEGIN_NAMESPACE
 template <> struct formatter<Answer> : formatter<int> {
   template <typename FormatContext>
   auto format(Answer, FormatContext& ctx) -> decltype(ctx.out()) {
@@ -1503,12 +1501,14 @@ template <> struct formatter<Answer> : formatter<int> {
 };
 FMT_END_NAMESPACE
 
-TEST(FormatterTest, CustomFormat) {
-  EXPECT_EQ("42", format("{0}", Answer()));
-  EXPECT_EQ("0042", format("{:04}", Answer()));
+TEST(format_test, format_custom) {
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:s}"), date(2012, 12, 9)),
+                   format_error, "unknown format specifier");
+  EXPECT_EQ("42", fmt::format("{0}", Answer()));
+  EXPECT_EQ("0042", fmt::format("{:04}", Answer()));
 }
 
-TEST(FormatterTest, CustomFormatTo) {
+TEST(format_test, format_to_custom) {
   char buf[10] = {};
   auto end =
       &*fmt::format_to(fmt::detail::make_checked(buf, 10), "{}", Answer());
@@ -1516,28 +1516,20 @@ TEST(FormatterTest, CustomFormatTo) {
   EXPECT_STREQ(buf, "42");
 }
 
-TEST(FormatterTest, WideFormatString) {
-  EXPECT_EQ(L"42", format(L"{}", 42));
-  EXPECT_EQ(L"4.2", format(L"{}", 4.2));
-  EXPECT_EQ(L"abc", format(L"{}", L"abc"));
-  EXPECT_EQ(L"z", format(L"{}", L'z'));
-}
-
-TEST(FormatterTest, FormatStringFromSpeedTest) {
+TEST(format_test, format_string_from_speed_test) {
   EXPECT_EQ("1.2340000000:0042:+3.13:str:0x3e8:X:%",
-            format("{0:0.10f}:{1:04}:{2:+g}:{3}:{4}:{5}:%", 1.234, 42, 3.13,
-                   "str", reinterpret_cast<void*>(1000), 'X'));
+            fmt::format("{0:0.10f}:{1:04}:{2:+g}:{3}:{4}:{5}:%", 1.234, 42,
+                        3.13, "str", reinterpret_cast<void*>(1000), 'X'));
 }
 
-TEST(FormatterTest, FormatExamples) {
-  std::string message = format("The answer is {}", 42);
+TEST(format_test, format_examples) {
+  std::string message = fmt::format("The answer is {}", 42);
   EXPECT_EQ("The answer is 42", message);
 
-  EXPECT_EQ("42", format("{}", 42));
-  EXPECT_EQ("42", format(std::string("{}"), 42));
+  EXPECT_EQ("42", fmt::format("{}", 42));
 
   memory_buffer out;
-  format_to(out, "The answer is {}.", 42);
+  format_to(std::back_inserter(out), "The answer is {}.", 42);
   EXPECT_EQ("The answer is 42.", to_string(out));
 
   const char* filename = "nonexistent";
